diff --git a/rtslib/config_parser.py b/rtslib/config_parser.py
new file mode 100644
index 0000000..f85aa55
--- /dev/null
+++ b/rtslib/config_parser.py
@@ -0,0 +1,291 @@
+'''
+This file is part of the LIO SCSI Target.
+
+Copyright (c) 2012-2014 by Datera, Inc.
+More information on www.datera.io.
+
+Original author: Jerome Martin <jxm@netiant.com>
+
+Datera and LIO are trademarks of Datera, Inc., which may be registered in some
+jurisdictions.
+
+Licensed under the Apache License, Version 2.0 (the "License"); you may
+not use this file except in compliance with the License. You may obtain
+a copy of the License at
+
+    http://www.apache.org/licenses/LICENSE-2.0
+
+Unless required by applicable law or agreed to in writing, software
+distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
+WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
+License for the specific language governing permissions and limitations
+under the License.
+'''
+import logging
+import pyparsing as pp
+
+from config_tree import NO_VALUE
+
+# TODO Add strategic debug (and logging too, it is absent)
+# TODO Using group names as we do with obj_classes would be more robust
+
+DEBUG = False
+if DEBUG:
+    logging.basicConfig()
+    log = logging.getLogger('ConfigParser')
+    log.setLevel(logging.DEBUG)
+else:
+    log = logging.getLogger('ConfigParser')
+    log.setLevel(logging.INFO)
+
+class ConfigParser(object):
+    '''
+    Our configuration format parser.
+    '''
+    # Order is important, used for sorting in Config
+    obj_classes = "storage disk fabric target tpgt lun acl portal mapped_lun"
+
+    def __init__(self):
+        self._init_parser()
+
+    def _init_parser(self):
+        pp.ParserElement.setDefaultWhitespaceChars(' \t')
+
+        tok_comment = pp.Regex(r'#.*')
+        tok_ws = pp.Suppress(pp.OneOrMore(pp.White(' \t')))
+        tok_delim = (pp.Optional(pp.Suppress(tok_comment))
+                     + pp.Suppress(pp.lineEnd | pp.Literal(';')))
+
+        tok_string = (pp.QuotedString('"')
+                      | pp.QuotedString("'")
+                      | pp.Word(pp.printables, excludeChars="{}#'\";"))
+
+        tok_obj_class = pp.oneOf(self.obj_classes)
+        tok_obj_ident = tok_string
+        tok_obj = pp.Group(tok_obj_class
+                           + tok_ws
+                           + tok_obj_ident)
+        tok_obj = tok_obj.setParseAction(self._parse_action_obj)
+
+        tok_attr_name = pp.Word(pp.alphas, pp.alphas + pp.nums + "_")
+        tok_attr_value = tok_string
+        tok_attr = pp.Group(tok_attr_name
+                            + tok_ws
+                            + tok_attr_value
+                            + pp.Optional(tok_comment))
+        tok_attr = tok_attr.setParseAction(self._parse_action_attr)
+
+        tok_group = pp.Word(pp.alphas, pp.alphas + "_") 
+        tok_group = tok_group.setParseAction(self._parse_action_group)
+
+        # FIXME This does not work as intended when used
+        # tok_empty_block = pp.Suppress('{' + pp.ZeroOrMore(tok_delim) + '}')
+
+        tok_statement = pp.Forward()
+        tok_block = (pp.Group(pp.Suppress('{')
+                              + pp.OneOrMore(tok_statement)
+                              + pp.Suppress('}')))
+        tok_block = tok_block.setParseAction(self._parse_action_block)
+
+        tok_statement_no_path = ((tok_group + tok_ws + tok_attr)
+                                 #| (tok_group + tok_empty_block)
+                                 | (tok_group + tok_block)
+                                 | tok_attr)
+
+        tok_optional_if_path = ((tok_ws + tok_group + tok_ws + tok_attr)
+                                #| (tok_ws + tok_group + tok_empty_block)
+                                | (tok_ws + tok_group + tok_block)
+                                #| tok_empty_block
+                                | tok_block
+                                | (tok_ws + tok_attr))
+
+        tok_statement_if_path = (pp.OneOrMore(tok_obj)
+                                 + pp.Optional(tok_optional_if_path))
+
+        tok_statement << pp.Group(pp.ZeroOrMore(tok_delim)
+                                  + (tok_statement_if_path
+                                     | tok_statement_no_path)
+                                  + pp.OneOrMore(tok_delim))
+
+        self._parser = pp.ZeroOrMore(tok_statement)
+
+    def _parse_action_obj(self, source, idx, tokin):
+        value = tokin[0]
+        return [{'type': 'obj',
+                 'line': pp.lineno(idx, source),
+                 'col': pp.col(idx, source),
+                 'key': (value[0], value[1])}]
+
+    def _parse_action_attr(self, source, idx, tokin):
+        value = tokin[0]
+        tokout = {'type': 'attr',
+                  'line': pp.lineno(idx, source),
+                  'col': pp.col(idx, source),
+                  'key': (value[0], value[1])}
+        if len(value) > 2:
+            tokout['comment'] = value[2][1:].strip()
+        return [tokout]
+
+    def _parse_action_group(self, source, idx, tokin):
+        value = tokin
+        return [{'type': 'group',
+                 'line': pp.lineno(idx, source),
+                 'col': pp.col(idx, source),
+                 'key': (value[0],)}]
+
+    def _parse_action_block(self, source, idx, tokin):
+        value = tokin[0].asList()
+        return [{'type': 'block',
+                 'line': pp.lineno(idx, source),
+                 'col': pp.col(idx, source),
+                 'statements': value}]
+
+    def parse_file(self, filepath):
+        return self._parser.parseFile(filepath, parseAll=True).asList()
+
+    def parse_string(self, string):
+        return self._parser.parseString(string, parseAll=True).asList()
+
+class PolicyParser(ConfigParser):
+    '''
+    Our policy format parser.
+    '''
+    def _init_parser(self):
+        # TODO Once stable, factorize with ConfigParser
+        pp.ParserElement.setDefaultWhitespaceChars(' \t')
+
+        tok_comment = pp.Regex(r'#.*')
+        tok_ws = pp.Suppress(pp.OneOrMore(pp.White(' \t')))
+        tok_delim = (pp.Optional(pp.Suppress(tok_comment))
+                     + pp.Suppress(pp.lineEnd | pp.Literal(';')))
+
+        tok_string = (pp.QuotedString('"')
+                      | pp.QuotedString("'")
+                      | pp.Word(pp.printables, excludeChars="{}#'\";%@()"))
+
+        tok_ref_path = (pp.Suppress('@') + pp.Suppress('(')
+                        + pp.OneOrMore(tok_string)
+                        + pp.Suppress(')'))
+
+        tok_id_rule = pp.Suppress('%') + tok_string("id_type")
+
+        tok_val_rule = (pp.Suppress('%')
+                        + tok_string("val_type")
+                        + pp.Optional(pp.Suppress('(')
+                                      + tok_string("val_dfl")
+                                      + pp.Suppress(')')))
+
+        tok_obj_class = pp.oneOf(self.obj_classes)
+        tok_obj_ident = tok_id_rule | tok_string("id_fixed")
+        tok_obj = pp.Group(tok_obj_class("class")
+                           + tok_ws
+                           + tok_obj_ident)
+        tok_obj = tok_obj.setParseAction(self._parse_action_obj)
+
+        tok_attr_name = pp.Word(pp.alphas, pp.alphas + pp.nums + "_")
+        tok_attr_value = tok_ref_path("ref_path") | tok_val_rule
+        tok_attr = pp.Group(tok_attr_name("name")
+                            + tok_ws
+                            + tok_attr_value
+                            + pp.Optional(tok_comment)("comment"))
+        tok_attr = tok_attr.setParseAction(self._parse_action_attr)
+
+        tok_group = pp.Word(pp.alphas, pp.alphas + "_") 
+        tok_group = tok_group.setParseAction(self._parse_action_group)
+
+        tok_statement = pp.Forward()
+        tok_block = (pp.Group(pp.Suppress('{')
+                              + pp.OneOrMore(tok_statement)
+                              + pp.Suppress('}')))
+        tok_block = tok_block.setParseAction(self._parse_action_block)
+
+        tok_statement_no_path = ((tok_group + tok_ws + tok_attr)
+                                 | (tok_group + tok_block)
+                                 | tok_attr)
+
+        tok_optional_if_path = ((tok_ws + tok_group + tok_ws + tok_attr)
+                                | (tok_ws + tok_group + tok_block)
+                                | tok_block
+                                | (tok_ws + tok_attr))
+
+        tok_statement_if_path = (pp.OneOrMore(tok_obj)
+                                 + pp.Optional(tok_optional_if_path))
+
+        tok_statement << pp.Group(pp.ZeroOrMore(tok_delim)
+                                  + (tok_statement_if_path
+                                     | tok_statement_no_path)
+                                  + pp.OneOrMore(tok_delim))
+
+        self._parser = pp.ZeroOrMore(tok_statement)
+
+    def _parse_action_attr(self, source, idx, tokin):
+        value = tokin[0].asDict()
+        ref_path = value.get('ref_path')
+        if ref_path is not None:
+            ref_path = " ".join(ref_path.asList())
+        tokout = {'type': 'attr',
+                  'line': pp.lineno(idx, source),
+                  'col': pp.col(idx, source),
+                  'ref_path': ref_path,
+                  'val_type': value.get('val_type'),
+                  'val_dfl': value.get('val_dfl', NO_VALUE),
+                  'required': value.get('val_dfl', NO_VALUE) == NO_VALUE,
+                  'comment': value.get('comment'),
+                  'key': (value.get('name'), 'xxx')}
+
+        return [tokout]
+
+    def _parse_action_obj(self, source, idx, tokin):
+        value = tokin[0].asDict()
+        return [{'type': 'obj',
+                 'line': pp.lineno(idx, source),
+                 'col': pp.col(idx, source),
+                 'id_type': value.get('id_type'),
+                 'id_fixed': value.get('id_fixed'),
+                 'key': (value.get('class'), value.get('id_fixed', 'xxx'))}]
+
+class PatternParser(ConfigParser):
+    '''
+    Our pattern format parser.
+    '''
+    def _init_parser(self):
+        # TODO Once stable, factorize with ConfigParser
+        pp.ParserElement.setDefaultWhitespaceChars(' \t')
+
+        tok_ws = pp.Suppress(pp.OneOrMore(pp.White(' \t')))
+
+        tok_string = (pp.QuotedString('"')
+                      | pp.QuotedString("'")
+                      | pp.Word(pp.printables, excludeChars="{}#'\";"))
+
+        tok_obj_class = pp.oneOf(self.obj_classes)
+        tok_obj_ident = tok_string
+        tok_obj = pp.Group(tok_obj_class + tok_ws + tok_obj_ident)
+        tok_obj = tok_obj.setParseAction(self._parse_action_obj_attr)
+
+        tok_attr_name = pp.Word(pp.alphas + pp.nums + "_.*[]-")
+        tok_attr_value = tok_string
+        tok_attr = pp.Group(tok_attr_name + tok_ws + tok_attr_value)
+        tok_attr = tok_attr.setParseAction(self._parse_action_obj_attr)
+
+        tok_group = pp.Word(pp.alphas + "_.*[]-") 
+        tok_group = tok_group.setParseAction(self._parse_action_group)
+
+        tok_statement_no_path = ((tok_group + tok_ws + tok_attr)
+                                 | tok_attr
+                                 | tok_group)
+
+        tok_optional_if_path = ((tok_ws + tok_group + tok_ws + tok_attr)
+                                | (tok_ws + tok_attr)
+                                | (tok_ws + tok_group))
+
+        tok_statement_if_path = (pp.OneOrMore(tok_obj)
+                                 + pp.Optional(tok_optional_if_path))
+
+        self._parser = tok_statement_if_path | tok_statement_no_path
+
+    def _parse_action_obj_attr(self, source, idx, tokin):
+        return (tokin[0][0], tokin[0][1])
+
+    def _parse_action_group(self, source, idx, tokin):
+        return (tokin[0],)
diff --git a/rtslib/config_tree.py b/rtslib/config_tree.py
new file mode 100644
index 0000000..5960a86
--- /dev/null
+++ b/rtslib/config_tree.py
@@ -0,0 +1,329 @@
+'''
+This file is part of the LIO SCSI Target.
+
+Copyright (c) 2012-2014 by Datera, Inc.
+More information on www.datera.io.
+
+Original author: Jerome Martin <jxm@netiant.com>
+
+Datera and LIO are trademarks of Datera, Inc., which may be registered in some
+jurisdictions.
+
+Licensed under the Apache License, Version 2.0 (the "License"); you may
+not use this file except in compliance with the License. You may obtain
+a copy of the License at
+
+    http://www.apache.org/licenses/LICENSE-2.0
+
+Unless required by applicable law or agreed to in writing, software
+distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
+WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
+License for the specific language governing permissions and limitations
+under the License.
+'''
+import re, copy, logging
+
+DEBUG = False
+if DEBUG:
+    logging.basicConfig()
+    log = logging.getLogger('ConfigTree')
+    log.setLevel(logging.DEBUG)
+else:
+    log = logging.getLogger('ConfigTree')
+    log.setLevel(logging.INFO)
+
+NO_VALUE = '~~~'
+
+def match_key(search_key, key):
+    '''
+    Matches search_key and key tuple items-for-item, with search_key containing
+    regular expressions patterns or None values, and key containing string ir
+    None values.
+    '''
+    log.debug("match_key(%s, %s)" % (search_key, key))
+    if len(search_key) == len(key):
+        for idx, pattern in enumerate(search_key):
+            item = key[idx]
+            if not pattern.endswith('$'):
+                pattern = "%s$" % pattern
+            if item is None and pattern is None:
+                continue
+            elif item is None:
+                break
+            else:
+                match = re.match(pattern, item)
+                if match is None:
+                    break
+        else:
+            return True
+
+class ConfigTreeError(Exception):
+    pass
+
+class ConfigTree(object):
+    '''
+    An ordered tree structure to hold configuration data.
+
+    A node can be referred to by its path, relative to the current node.
+    A path is a list of keys, each key a tuple of either string or None items.
+    '''
+    def __init__(self, data=None,
+                 sort_key=lambda x:x,
+                 key_to_string=lambda x:str(x)):
+        '''
+        Initializes a new ConfigTree.
+
+        The optional sort_key is a function used when ordering children of a
+        configuration node.
+
+        The optional key_to_string is a function used when converting a node
+        key to string.
+
+        Direct instanciation should only happen for the root node of the tree.
+        Adding a new node to the tree is achieved by using the set()
+        method of the desired parent for that new node.
+        '''
+        self.data = data
+
+        self._key = ()
+        self._nodes = {}
+        self._parent = None
+        self._sort_key = sort_key
+        self._key_to_string = key_to_string
+
+    def __repr__(self):
+        return "(%s)" % self.path_str
+
+    def __str__(self):
+        return self.path_str
+
+    def get_clone(self, parent=None):
+        '''
+        Returns a clone of the ConfigTree, not sharing any mutable data.
+        '''
+        clone = ConfigTree(copy.deepcopy(self.data),
+                           self._sort_key,
+                           self._key_to_string)
+        clone._parent = parent
+        clone._key = self._key
+        clone.data = copy.deepcopy(self.data)
+        for node in self.nodes:
+            clone._nodes[node.key] = node.get_clone(parent=clone)
+        return clone
+
+    @property
+    def root(self):
+        '''
+        Returns the root node of the tree.
+        '''
+        cur = self
+        while cur.parent:
+            cur = cur.parent
+        return cur
+
+    @property
+    def key(self):
+        '''
+        Returns the current node's key tuple.
+        '''
+        return self._key
+
+    @property
+    def key_str(self):
+        '''
+        Returns the current node's key as a string.
+        '''
+        return self._key_to_string(self.key)
+
+    @property
+    def path(self):
+        '''
+        Returns the node's full path from the tree root as a list of keys.
+        '''
+        if self.is_root:
+            path = []
+        else:
+            path = self.parent.path + [self._key]
+        return path
+
+    @property
+    def path_str(self):
+        '''
+        Returns the node's full path from the tree root as a string.
+        '''
+        strings = []
+        for key in self.path:
+            strings.append(self._key_to_string(key))
+        return " ".join(strings)
+
+    @property
+    def nodes(self):
+        '''
+        Returns the list of all children nodes, sorted with potential
+        dependencies first.
+        '''
+        nodes = sorted(self._nodes.values(), key=self._sort_key)
+        return nodes
+
+    @property
+    def keys(self):
+        '''
+        Generates all children nodes keys, sorted with potential
+        dependencies first.
+        '''
+        keys = (node.key for node in self.nodes)
+        return keys
+
+    @property
+    def parent(self):
+        '''
+        Returns the parent node of the current node, or None.
+        '''
+        return self._parent
+
+    @property
+    def is_root(self):
+        '''
+        Returns True if this is a root node, else False.
+        '''
+        return self._parent == None
+
+    def get(self, node_key):
+        '''
+        Returns the current node's child having node_key, or None.
+        '''
+        return self._nodes.get(node_key)
+
+    def set(self, node_key, node_data=None):
+        '''
+        Creates and adds a child node to the current node, and returns that new
+        node. If the node already exists, then a ConfigTreeError exception will
+        be raised. Else, the new node will be returned.
+
+        node_key is any tuple of strings
+        node_data is an optional arbitrary value
+        '''
+        if node_key not in self.keys:
+            new_node = ConfigTree(self.data,
+                                  self._sort_key,
+                                  self._key_to_string)
+            new_node._parent = self
+            new_node.data = node_data
+            new_node._key = node_key
+            self._nodes[node_key] = new_node
+            return new_node
+        else:
+            raise ConfigTreeError("Node already exists, cannot set: %s"
+                                  % self.get(node_key))
+
+    def cine(self, node_key, node_data=None):
+        '''
+        cine stands for create if not exist: it makes sure a node exists.
+        If it does not, it will create it using node_data.
+        Else node_data will not be updated.
+
+        Returns the matching node in all cases.
+
+        node_key is any tuple of strings
+        node_data is an optional arbitrary value
+        '''
+        if node_key in self.keys:
+            log.debug("cine(%s %s) -> Already exists"
+                      % (self.path_str, node_key))
+            return self.get(node_key)
+        else:
+            log.debug("cine(%s %s) -> Creating"
+                      % (self.path_str, node_key))
+            return self.set(node_key, node_data)
+
+    def update(self, node_key, node_data=None):
+        '''
+        If a node already has node_key as key, its data will be replaced with
+        node_data. Else, it will be created using node_data.
+
+        The matching node will be returned in both cases.
+
+        node_key is any tuple of strings.
+        node_data is an optional arbitrary value.
+        '''
+        try:
+            node = self.set(node_key, node_data)
+        except ConfigTreeError:
+            node = self.get(node_key)
+            node.data = node_data
+        return node
+
+    def delete(self, path):
+        '''
+        Given a path, deletes an entire subtree from the configuration,
+        relative to the current node.
+
+        The deleted subtree will be returned, or None is the path does not
+        exist or is empty. The path must be a list of node keys.
+        '''
+        log.debug("delete(%s) getting subtree" % str(path))
+        subtree = self.get_path(path)
+        log.debug("delete(%s) got subtree: %s"
+                  % (str(path), subtree))
+        if subtree is not None:
+            del subtree.parent._nodes[subtree.key]
+        return subtree
+    
+    def get_path(self, path):
+        '''
+        Returns either the node matching path, relative to the current node, or
+        None if the path does not exists.
+        '''
+        log.debug("get_path(%s)" % str(path))
+        cur = self
+        log.debug("get_path(%s) - cur: %s" % (str(path), cur))
+        if path:
+            for key in path:
+                cur = cur.get(key)
+                if cur is None:
+                    break
+            else:
+                return cur
+
+    def search(self, search_path, node_filter=lambda x:x):
+        '''
+        Returns a list of nodes matching the search_path, relative to the
+        current node, or an empty list if no match was found.
+
+        The search_path is a list of node search_key. Each will be matched
+        against node key tuples items-for-item, with search_key containing
+        regular expressions patterns or None values, and key containing string
+        or None values.
+
+        node_filter is a function applied to each node before returning it:
+            node_filter(node_in) -> node_out | None (aka filtered out)
+        '''
+        results = []
+        if search_path:
+            search_key = search_path[0]
+            for node in self.nodes:
+                if match_key(search_key, node.key):
+                    if search_path[1:]:
+                        results.extend(node.search(search_path[1:]))
+                    else:
+                        node_out = node_filter(node)
+                        if node_out is not None:
+                            results.append(node_out)
+        return results
+
+    def walk(self, node_filter=lambda x:x):
+        '''
+        Returns a generator yielding our children's tree in depth-first order.
+
+        node_filter is a function applied to each node before dumping it:
+            node_filter(node_in) -> node_out | None (aka filtered out)
+
+        When a node is filtered out, its children will still be walked and
+        filtered/yielded as usual.
+        '''
+        for node_in in self.nodes:
+            node_out = node_filter(node_in)
+            if node_out is not None:
+                yield node_out
+            for next in node_in.walk(node_filter):
+                yield next
diff --git a/rtslib/node.py b/rtslib/node.py
index 77a1cbc..4107065 100644
--- a/rtslib/node.py
+++ b/rtslib/node.py
@@ -2,7 +2,7 @@
 Implements the base CFSNode class and a few inherited variants.
 
 This file is part of RTSLib.
-Copyright (c) 2011-2013 by Datera, Inc
+Copyright (c) 2011-2014 by Datera, Inc
 
 Licensed under the Apache License, Version 2.0 (the "License"); you may
 not use this file except in compliance with the License. You may obtain
@@ -24,8 +24,6 @@ from utils import fread, fwrite, RTSLibError, RTSLibNotInCFS
 
 class CFSNode(object):
 
-    # Where do we store the fabric modules spec files ?
-    spec_dir = "/var/target/fabric"
     # Where is the configfs base LIO directory ?
     configfs_dir = '/sys/kernel/config/target'
     # TODO: Make the ALUA path generic, not iscsi-centric
@@ -51,11 +49,11 @@ class CFSNode(object):
 
     def _create_in_cfs_ine(self, mode):
         '''
-        Creates the configFS node if it does not already exists depending on
+        Creates the configFS node if it does not already exist depending on
         the mode.
-        any -> makes sure it exists, also works if the node already does exists
-        lookup -> make sure it does NOT exists
-        create -> create the node which must not exists beforehand
+        any -> makes sure it exists, also works if the node already does exist
+        lookup -> make sure it does NOT exist
+        create -> create the node which must not exist beforehand
         Upon success (no exception raised), self._fresh is True if a node was
         created, else self._fresh is False.
         '''
@@ -67,11 +65,16 @@ class CFSNode(object):
         elif not self and mode == 'lookup':
             raise RTSLibNotInCFS("No such %s in configfs: %s."
                                  % (self.__class__.__name__, self.path))
-        if not self:
+        if self:
+            self._fresh = False
+            return
+
+        try:
             os.mkdir(self.path)
             self._fresh = True
-        else:
-            self._fresh = False
+        except:
+            raise RTSLibError("Could not create %s in configFS."
+                              % self.__class__.__name__)
 
     def _exists(self):
         return bool(self)
@@ -167,10 +170,10 @@ class CFSNode(object):
         else:
             try:
                 fwrite(path, "%s\n" % str(value))
-            except IOError, msg:
+            except Exception, msg:
                 msg = msg[1]
-                raise RTSLibError("Cannot set attribute %s: %s"
-                                  % (str(attribute), str(msg)))
+                raise RTSLibError("Cannot set attribute %s to '%s': %s"
+                                  % (str(attribute), str(value), str(msg)))
 
     def get_attribute(self, attribute):
         '''
@@ -202,7 +205,7 @@ class CFSNode(object):
         else:
             try:
                 fwrite(path, "%s\n" % str(value))
-            except IOError, msg:
+            except Exception, msg:
                 msg = msg[1]
                 raise RTSLibError("Cannot set parameter %s: %s"
                                   % (str(parameter), str(msg)))
diff --git a/rtslib/root.py b/rtslib/root.py
index 970057f..9f32403 100644
--- a/rtslib/root.py
+++ b/rtslib/root.py
@@ -2,7 +2,7 @@
 Implements the RTSRoot class.
 
 This file is part of RTSLib.
-Copyright (c) 2011-2013 by Datera, Inc
+Copyright (c) 2011-2014 by Datera, Inc
 
 Licensed under the Apache License, Version 2.0 (the "License"); you may
 not use this file except in compliance with the License. You may obtain
@@ -24,8 +24,8 @@ import glob
 from node import CFSNode
 from target import Target, FabricModule
 from tcm import FileIOBackstore, IBlockBackstore
-from tcm import PSCSIBackstore, RDDRBackstore, RDMCPBackstore
-from utils import RTSLibError, RTSLibBrokenLink, flatten_nested_list, modprobe
+from tcm import PSCSIBackstore, RDMCPBackstore
+from utils import RTSLibError, RTSLibBrokenLink, modprobe
 
 class RTSRoot(CFSNode):
     '''
@@ -70,12 +70,11 @@ class RTSRoot(CFSNode):
         self._check_self()
         targets = set([])
         for fabric_module in self.fabric_modules:
-            targets.update(fabric_module.targets)
-        return targets
+            for target in fabric_module.targets:
+                yield target
 
     def _list_backstores(self):
         self._check_self()
-        backstores = set([])
         if os.path.isdir("%s/core" % self.path):
             backstore_dirs = glob.glob("%s/core/*_*" % self.path)
             for backstore_dir in [os.path.basename(path)
@@ -84,58 +83,58 @@ class RTSRoot(CFSNode):
                                   backstore_dir)
                 if regex:
                     if regex.group(1) == "fileio":
-                        backstores.add(
-                            FileIOBackstore(int(regex.group(3)), 'lookup'))
+                        yield FileIOBackstore(int(regex.group(3)), 'lookup')
                     elif regex.group(1) == "pscsi":
-                        backstores.add(
-                            PSCSIBackstore(int(regex.group(3)), 'lookup'))
+                        yield PSCSIBackstore(int(regex.group(3)), 'lookup')
                     elif regex.group(1) == "iblock":
-                        backstores.add(
-                            IBlockBackstore(int(regex.group(3)), 'lookup'))
-                    elif regex.group(1) == "rd_dr":
-                        backstores.add(
-                            RDDRBackstore(int(regex.group(3)), 'lookup'))
+                        yield IBlockBackstore(int(regex.group(3)), 'lookup')
                     elif regex.group(1) == "rd_mcp":
-                        backstores.add(
-                            RDMCPBackstore(int(regex.group(3)), 'lookup'))
-        return backstores
+                        yield RDMCPBackstore(int(regex.group(3)), 'lookup')
 
     def _list_storage_objects(self):
         self._check_self()
-        return set(flatten_nested_list([backstore.storage_objects
-                                        for backstore in self.backstores]))
+        for bs in self.backstores:
+            for so in bs.storage_objects:
+                yield so
 
     def _list_tpgs(self):
         self._check_self()
-        return set(flatten_nested_list([t.tpgs for t in self.targets]))
+        for t in self.targets:
+            for tpg in t.tpgs:
+                yield tpg
 
     def _list_node_acls(self):
         self._check_self()
-        return set(flatten_nested_list([t.node_acls for t in self.tpgs]))
+        for t in self.tpgs:
+            for node_acl in t.node_acls:
+                yield node_acl
 
     def _list_network_portals(self):
         self._check_self()
-        return set(flatten_nested_list([t.network_portals for t in self.tpgs]))
+        for t in self.tpgs:
+            for p in t.network_portals:
+                yield p
 
     def _list_luns(self):
         self._check_self()
-        return set(flatten_nested_list([t.luns for t in self.tpgs]))
+        for t in self.tpgs:
+            for lun in t.luns:
+                yield lun
 
     def _list_fabric_modules(self):
         self._check_self()
-        mod_names = [mod_name[:-5] for mod_name in os.listdir(self.spec_dir)
-                     if mod_name.endswith('.spec')]
-        modules = [FabricModule(mod_name) for mod_name in mod_names]
-        return modules
+        for mod in FabricModule.all():
+            yield mod
 
     def _list_loaded_fabric_modules(self):
-        return [fm for fm in self._list_fabric_modules() if fm.exists]
+        for module in self._list_fabric_modules():
+            if module.exists:
+                yield module
 
     def __str__(self):
-        return "rtsadmin"
+        return "rtslib"
 
     # RTSRoot public stuff
-
     backstores = property(_list_backstores,
             doc="Get the list of Backstore objects.")
     targets = property(_list_targets,
